// JavaScript Document
/*
 * two extra easing methods used in this application
 * expand jquery.easing property
 */
var Trans={
		Cubic:function(p){
			return Math.pow(p,3);	
		},
		Elastic:function(p,x){
		  return Math.pow(2,10*--p)*Math.cos(20*p*Math.PI*(x[0]||1)/3);
		}
}
/*
$.each(['Quad','Cubic','Quart','Quint'],function(index,name){
		Trans[name]=function(p){
		   return Math.pow(p,[index+2]);
		}
});
*/
$.extend($.easing,Trans);
$.each(Trans,function(key,method){
	$.easing[key+"EaseOut"]=(function(method){
		return function(p,x){
			return 1-method(1-p,x);	
		};						  
	})(method)
	$.easing[key+"EaseInOut"]=(function(method){
		return function(p,x){
			return (p<=0.5)?method(2*p,x)/2:(2-method(2*(1-p),x))/2;
		}
	})(method)
	
})
/*
 * define a namespace
 * inspiration comes from http://www.apple.com/mac/ product browser's transition in chorme,who support css transition;
 */
var apple={};
apple.slide={
	current:-1,
	innerWidth:150,
	groupClass:".apple-wrap",
	innerClass:".apple-inner",
	nav:"#apple-nav span",
	caret:".apple-caret",
	setup:function(){
		var o=apple.slide;
		$(o.groupClass).each(function(index){
			var children=$(this).find(o.innerClass),
				len=children.length,
				_width=len*o.innerWidth;
			$(this).css({marginLeft:_width/-2+'px',width:_width+'px'});
			children.each(function(i){
				$(this).css({left:o.innerWidth*i+'px',marginLeft:"2000px"});
			});
		});
		o.initNav();
	},
	initNav:function(){
		var o=apple.slide;
		$(o.nav).each(function(i){
			if(i>=$(o.groupClass).length){
				return false;	
			}
			$(this).click(function(){
				var ap=apple.slide;
				if(ap.current==i||ap.isAnimate){
					return;	
				}
				ap.isAnimate=true;
				ap.slideOut(i);
				ap.slideIn(i);
				ap.slideCaret(i);
			});
		});	
		$(o.nav).eq(0).trigger("click");
	},
	slideOut:function(index){
		var o=apple.slide,
			dir=index>o.current?-1:1,
			inner=$(o.groupClass).eq(o.current).find(o.innerClass);
		inner.each(function(i){
			var _this=$(this),
				delay=dir==-1?i:inner.length-i-1;
			setTimeout(function(){
				_this.animate({marginLeft:dir*2000+'px'},1000,"CubicEaseOut");					
			},delay*50)														   
		});
	},
	slideIn:function(index){
		var o=apple.slide,
			dir=index>o.current?1:-1,
			inner=$(o.groupClass).eq(index).find(o.innerClass);
		inner.each(function(i){
			$(this).css({marginLeft:dir*2000+'px'});					
		});
		inner.each(function(n){
			var _this=$(this),
				delay=dir==1?n:inner.length-n-1;
			setTimeout(function(){
				_this.animate({marginLeft:dir-50+'px'},1000,"Cubic");	
				_this.animate({marginLeft:"0"},300,"ElasticEaseOut",function(){
					if(n==inner.length-1){
						o.current=index;
						o.isAnimate=false;
					}								  
				});						
			},delay*50);
		});
	},
	slideCaret:function(index){
		var obj=$(apple.slide.nav).eq(index),
			pos=obj.position(),
			width=obj.get(0).offsetWidth;
		$(apple.slide.caret).animate({left:pos.left+width/2-8+'px'});
	}
	
}
apple.slide.setup();